#!/usr/bin/env python
# -*- coding: UTF-8 -*-
 
import os
import time
import threading
import gps
import SocketServer
 
gps_g=None  # nimmt die gps-Klasse auf
run_tracker_g=True
trackpoints_written_g=0

HOME_DIR=os.path.expanduser('~')
LOG_FILE=os.path.join(HOME_DIR, "usbstick/recordings", time.strftime("%Y_%m_%d_%H_%M_%S")+".gpx")

# ######################################################################
# Schreibt das gpx-File.
class TrackWriter():
  def __init__(self):
    strg='<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>\n' \
          '<gpx version="1.1" creator="RasPi Tracker" xmlns="http://www.topografix.com/GPX/1/1"' \
          ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"' \
          ' xsi:schemaLocation="http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd">\n' \
          '  <trk>\n' \
          '    <trkseg>\n'
    fobj=open(LOG_FILE, "a")
    fobj.write(strg)    
    fobj.close()
    self.strg='      <trkpt lat="%11.9f" lon="%11.9f"><time>%s</time></trkpt>\n'

  def write(self, lat, lon, tim):
    fobj=open(LOG_FILE, "a")
    fobj.write(self.strg%(lat, lon, tim))
    fobj.close()

  def close(self):
    fobj=open(LOG_FILE, "a")
    fobj.write('    </trkseg>\n  </trk>\n</gpx>')
    fobj.close()

# ######################################################################
# Liefert der WebSeite GPS-Daten.
class MyTCPHandler(SocketServer.BaseRequestHandler):
  def handle(self):
    global run_tracker_g, trackpoints_written_g
    inp=self.request.recv(1024)
    #print ">"+inp.decode()+"<"
    if inp.decode()=='GET DATA':
      snd="%11.9f;%11.9f;%s;%d;%d"%(gps_g.fix.latitude, gps_g.fix.longitude, gps_g.utc, numberOfUsedSatellites(), trackpoints_written_g)
      self.request.sendall(snd)
    elif inp.decode()=='STOP TRACKER':
      run_tracker_g=False
class SocketSrv(threading.Thread):
  def __init__(self):
    threading.Thread.__init__(self)
    self.server=SocketServer.TCPServer(("127.0.0.1", 42424), MyTCPHandler)

  def run(self):
    self.server.serve_forever()

  def die(self):
    self.server.shutdown()

 
# ######################################################################
# Eine Klasse, die ständig die aktuellen Daten des GPS-Moduls in der
# globalen Variable "gps_g" ablegt bzw. "gps_g" aktuell hält.
class GpsLatest(threading.Thread):
  def __init__(self):
    threading.Thread.__init__(self)
    global gps_g
    gps_g=gps.gps(mode=gps.WATCH_ENABLE)
    self.is_running=True

  def run(self):
    global gps_g
    while self.is_running:
      gps_g.next()

  def die(self):
    self.is_running=False

# ######################################################################
#
def numberOfUsedSatellites():
  cnt=0
  for c in gps_g.satellites:
    if c.used:
       cnt+=1
  return(cnt)

# ######################################################################
#
if __name__ == '__main__':
  gpsl=GpsLatest()
  socksrv=SocketSrv()
  socksrv.start()
  track=TrackWriter()

  try:
    gpsl.start()
    while run_tracker_g:
      #print "%11.9f  %11.9f  %s   %2d"%(gps_g.fix.latitude, gps_g.fix.longitude, gps_g.utc, numberOfUsedSatellites())
      if gps_g.fix.latitude>0 and gps_g.fix.longitude>0 and gps_g.utc!="":
        trackpoints_written_g+=1
        track.write(gps_g.fix.latitude, gps_g.fix.longitude, gps_g.utc)
      time.sleep(5)
  except (KeyboardInterrupt, SystemExit):
    pass
  print "\nKilling Thread..."
  track.close()
  socksrv.die()
  gpsl.die()
  print "Done.\nExiting."
